<?php
/*
 * Spy Analytics
 * (c) 2013. Aleksej Sytnik
 */
?>
<?php
	//remove wp_debug notices if they will appear
	//we do not need it in loaded JS
	ob_end_clean();
	//secure check $_GET variables
	$_GET = array_map('secure', $_GET);  
	$option = get_option('spy_analytics_plugin');
	header("Content-type: application/javascript");
	//check page we want to record
	if(!$option['opt_record_status']) die('//empty js file');
	if(!$option['opt_record_all'] && !in_array($_GET['i'], $option['opt_record_special'])) die('//empty js file');
?>
	//functions to work with cookies
	function setCookie(e,t,n){var r=new Date;r.setDate(r.getDate()+n);var i=escape(t)+(n==null?"":"; expires="+r.toUTCString());document.cookie=e+"="+i}
	function getCookie(e){var t,n,r,i=document.cookie.split(";");for(t=0;t<i.length;t++){n=i[t].substr(0,i[t].indexOf("="));r=i[t].substr(i[t].indexOf("=")+1);n=n.replace(/^\s+|\s+$/g,"");if(n==e){return unescape(r)}}return null}
	
	//serialize/unserialize array function
	function serialize(arr){
		var parts = [];
		var is_list = (Object.prototype.toString.apply(arr) === '[object Array]');
		for(var key in arr) {
			var value = arr[key];
		    if(typeof value == "object") { 
			    if(is_list) parts.push(serialize(value)); 
			    else parts[key] = serialize(value); 
			} else {
			    var str = "";
				if(!is_list) str = '"' + key + '":';
				if(typeof value == "number") str += value; 
				else if(value === false) str += 'false'; 
				else if(value === true) str += 'true';
				else str += '"' + value + '"'; 
			    parts.push(str);
			}
		}
		var json = parts.join(",");		
		if(is_list) return '[' + json + ']';
		return '{' + json + '}';
	}
	function unserialize(e){
		return jQuery.parseJSON(e);
	}
	isActive = true;
	
	function initLogic(){
	jQuery(document).ready(function() {
		//check if window/tab is active
   		jQuery(window).focus(function() { isActive = true;});
    	jQuery(window).blur(function() { isActive = false;});
		//dont record in iframe
		if(top !== self) return false;
		//get user id from the cookies
		//create new if not exist 
		var myVar = getCookie("spy_analytics");
		if (myVar == null) {
			myVar = Math.floor((Math.random() * 1000000000) + 1);
			setCookie("spy_analytics", myVar, 365);
		}
		//get session id from the cookies
		//create new if not exist 
		var session_data = getCookie("spy_analytics_session");
		if (session_data == null) {
			session = [Math.floor((Math.random() * 1000000000) + 1), Math.floor(new Date().getTime()/1000)];
			setCookie("spy_analytics_session", serialize(session), 365);
		} else {
			var now = Math.floor(new Date().getTime()/1000);
			session = unserialize(session_data);
			if((now-session[1]) > <?php print $option['opt_record_kill_session']; ?>){
				session = [Math.floor((Math.random() * 1000000000) + 1), Math.floor(new Date().getTime()/1000)];
				setCookie("spy_analytics_session", serialize(session), 365);
			}
		}
		var lastmousex = 0, lastmousey = 0, lastscrollv = 0, lastscrollh = 0, lastwinh = 0, lastwinw = 0;
		var prevmousex = 0, prevmousey = 0, prevscrollv = 0, prevscrollh = 0, prevwinh = 0, prevwinw = 0;
		var mouse_move, mouse_click, page_scroll;
		var sendwhen = <?php print $option['opt_record_interval']; ?>*1000;
		var interval = 100;
		var time = 0;
		var sending = false;
		//timer for sending recorded actions to db
		setInterval(function() {
			//break when inactive current window/tab
			sending = true;
			var cur_sess_data = getCookie("spy_analytics_session");
			var cur_sess = unserialize(cur_sess_data);
			//get recorded data from the cookies
			var send_mousemove =  unserialize(getCookie("spy_analytics_buff_mouse_move")) || [];
			var send_pagescroll =  unserialize(getCookie("spy_analytics_buff_page_scroll")) || [];
			var send_mouse_click =  unserialize(getCookie("spy_analytics_buff_mouse_click")) || [];	
			var send_window_size =  unserialize(getCookie("spy_analytics_buff_window_size")) || [];		
			//if we have new actions from the users, send it	
			if(!(send_mousemove.length == 0 && send_pagescroll.length == 0 && send_mouse_click.length == 0 && send_window_size.length == 0) && isActive){
				jQuery.post("<?php echo home_url(); ?>/?spydata", {
					"user" : myVar,
					"page" : document.location.href,
					"session" : cur_sess[0],
					<?php if ($option['opt_record_mousemove']): ?>"mouse_move" : send_mousemove ,<?php endif; ?>
					<?php if ($option['opt_record_pagescroll']): ?>"page_scroll" : send_pagescroll ,<?php endif; ?>
					"mouse_click" : send_mouse_click,
					"window_size" : send_window_size
				}, function(data) {
				}, "json");
				//set empty arrays to the cookies
				mouse_move = new Array(); setCookie("spy_analytics_buff_mouse_move",serialize(mouse_move),365);
				page_scroll = new Array(); setCookie("spy_analytics_buff_page_scroll",serialize(page_scroll),365);
				mouse_click = new Array(); setCookie("spy_analytics_buff_mouse_click",serialize(mouse_click),365);
				window_size = new Array(); setCookie("spy_analytics_buff_window_size",serialize(window_size),365);
			} else {
			//if we do not have new actions from the user,
			//check session live time to create new if need
				var session_data = getCookie("spy_analytics_session");
				if (session_data == null) {
					session = [Math.floor((Math.random() * 1000000000) + 1), Math.floor(new Date().getTime()/1000)];
					setCookie("spy_analytics_session", serialize(session), 365);
				} else {
					var now = Math.floor(new Date().getTime()/1000);
					session = unserialize(session_data);
					if((now-session[1]) > <?php print $option['opt_record_kill_session']; ?>){
						session = [Math.floor((Math.random() * 1000000000) + 1), Math.floor(new Date().getTime()/1000)];
						setCookie("spy_analytics_session", serialize(session), 365);
					}
				}
			}
			sending = false;
		}, sendwhen)
		//record window size
		prevwinw = prevwinh = 0;
		lastwinh = jQuery(window).height();
		lastwinw = jQuery(window).width();
		//timer for record user actions
		setInterval(function() {
			//get session id
			var cur_sess_data = getCookie("spy_analytics_session");
			var cur_sess = unserialize(cur_sess_data);
			//if data was changed add it to array,
			//in this way we have optimized sending
			if((prevmousex != lastmousex || prevmousey != lastmousey) && !sending && <?php print ($option['opt_record_mousemove'])?'true':'false'; ?>){
				var mouse_move_buff = getCookie("spy_analytics_buff_mouse_move");
				if(mouse_move_buff != null) mouse_move = unserialize(mouse_move_buff);
				else mouse_move = new Array();
				mouse_move.push([document.location.href,time.toFixed(1),lastmousex,lastmousey,cur_sess[0]]);
				setCookie("spy_analytics_buff_mouse_move",serialize(mouse_move),365);
				prevmousex = lastmousex;
				prevmousey = lastmousey;
			}
			if((prevscrollv != lastscrollv || prevscrollh != lastscrollh) && !sending && <?php print ($option['opt_record_pagescroll'])?'true':'false'; ?>){
				var page_scroll_buff = getCookie("spy_analytics_buff_page_scroll");
				if(page_scroll_buff != null) page_scroll = unserialize(page_scroll_buff);
				else page_scroll = new Array();
				page_scroll.push([document.location.href,time.toFixed(1),lastscrollv,lastscrollh,cur_sess[0]]);
				setCookie("spy_analytics_buff_page_scroll",serialize(page_scroll),365)
				prevscrollv = lastscrollv;
				prevscrollh = lastscrollh;
			}
			if((prevwinw != lastwinw || prevwinh != lastwinh) && !sending){
				var window_size_buff = getCookie("spy_analytics_buff_window_size");
				if(window_size_buff != null) window_size = unserialize(window_size_buff);
				else window_size = new Array();
				window_size.push([document.location.href,time.toFixed(1),lastwinh,lastwinw,cur_sess[0]]);
				setCookie("spy_analytics_buff_window_size",serialize(window_size),365)
				prevwinw = lastwinw;
				prevwinh = lastwinh;
			}
			time += (interval/1000);
		}, interval)
		
		//mouse position
		jQuery("body").mousemove(function(e) {
			lastmousex = e.pageX;
			lastmousey = e.pageY;
		});
		
		//scroll
		jQuery(window).scroll(function(e) {
			lastscrollv = jQuery(document).scrollTop();
			lastscrollh = jQuery(document).scrollLeft();
		})
		
		//window resize
		jQuery(window).resize(function() {
			lastwinh = jQuery(window).height();
			lastwinw = jQuery(window).width();
		});
	});
	}//initLogic()
function waitForJQuery() {
	if (typeof jQuery != 'undefined') { // JQuery is loaded!
		initLogic();
		return;
	}
	setTimeout(waitForJQuery, 100); // Check 0,1 a second
	return;
}
function checkjQuery() {
	if (typeof jQuery == 'undefined') { 
		var script = document.createElement('script');
		script.type = "text/javascript";
		script.src = "http://code.jquery.com/jquery-latest.min.js";
		document.getElementsByTagName('head')[0].appendChild(script);
		waitForJQuery();
	} else {
		initLogic();
	}
}
if (window.addEventListener)
window.addEventListener("load", checkjQuery, false);
else if (window.attachEvent)
window.attachEvent("onload", checkjQuery);
